## kwin-zones 1.0.11

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Aleix Pol Gonzalez <aleix.pol_gonzalez@mercedes-benz.com>
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(kwin-zones VERSION 0.1)

set(QT_MIN_VERSION "6.4")
set(KF_MIN_VERSION "6.0")
set(KDE_COMPILERSETTINGS_LEVEL "5.82")

option(ONLY_CLIENT_BUILD "Build only KWinZones QML Client Plugin" OFF)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)

include(FeatureSummary)
include(GenerateExportHeader)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEClangFormat)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMQtDeclareLoggingCategory)
include(ECMQmlModule)
include(ECMSetupQtPluginMacroNames)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    WaylandClient
)

if (NOT ONLY_CLIENT_BUILD)
    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS Config)
    find_package(KWin 6.0 REQUIRED)
else()
    find_package(WaylandScanner REQUIRED)
endif()

find_package(WaylandProtocols REQUIRED)
find_package(Wayland 1.3 REQUIRED COMPONENTS Client)

find_package(QtWaylandScanner REQUIRED)
set_package_properties(QtWaylandScanner PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building this effect"
)

#add_definitions(-DQT_NO_KEYWORDS)

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_subdirectory(src)

if (NOT ONLY_CLIENT_BUILD)
    # add clang-format target for all our real source files
    file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
    kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Aleix Pol Gonzalez <aleix.pol_gonzalez@mercedes-benz.com>
# SPDX-License-Identifier: BSD-3-Clause

add_subdirectory(client)

if (NOT ONLY_CLIENT_BUILD)
    kcoreaddons_add_plugin(KWinZones INSTALL_NAMESPACE "kwin/plugins")
    target_sources(KWinZones PRIVATE main.cpp zones.cpp)

    kconfig_add_kcfg_files(KWinZones zonessettings.kcfgc)
    ecm_add_qtwayland_server_protocol(KWinZones
        PROTOCOL ext-zones-v1.xml
        BASENAME ext-zones-v1
    )
    ecm_qt_declare_logging_category(KWinZones
        HEADER kwinzonescompositorlogging.h
        IDENTIFIER KWINZONES
        CATEGORY_NAME kwinzones.compositor
        DEFAULT_SEVERITY Info
    )

    target_link_libraries(KWinZones KWin::kwin KF6::ConfigGui)
endif()

=== src/client/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Aleix Pol Gonzalez <aleix.pol_gonzalez@mercedes-benz.com>
# SPDX-License-Identifier: BSD-3-Clause

ecm_add_qml_module(QtZonesQuick
                  GENERATE_PLUGIN_SOURCE
                  URI "org.kde.zones"
                  VERSION 1.0
                  SOURCES zoneitemattached.cpp zonemanager.cpp)
target_link_libraries(QtZonesQuick PRIVATE Qt::Qml Qt::WaylandClient Qt::GuiPrivate Wayland::Client Qt::WaylandClientPrivate)

qt6_generate_wayland_protocol_client_sources(QtZonesQuick FILES
    ${Wayland_DATADIR}/wayland.xml
    ${WaylandProtocols_DATADIR}/stable/xdg-shell/xdg-shell.xml
    ${CMAKE_SOURCE_DIR}/src/ext-zones-v1.xml
)
ecm_qt_declare_logging_category(QtZonesQuick
    HEADER kwinzonesclientlogging.h
    IDENTIFIER KWINZONES_CLIENT
    CATEGORY_NAME kwinzones.client
    DEFAULT_SEVERITY Info
)

ecm_finalize_qml_module(QtZonesQuick DESTINATION ${KDE_INSTALL_QMLDIR})

=== debian/changelog ===
kwin-zones (1.0.11-1) unstable; urgency=medium

  * Initial release

 -- Matthias Klumpp <mak@debian.org>  Sat, 28 Feb 2026 20:46:32 +0100

=== debian/control ===
Source: kwin-zones
Section: kde
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.18.0~),
               kwin-dev,
               libdrm-dev,
               pkgconf,
               plasma-workspace-dev,
               qt6-base-dev (>= 6.9.0~),
               qt6-base-private-dev,
               qt6-declarative-dev,
               qt6-wayland-dev,
               qt6-wayland-private-dev,
               wayland-protocols
Standards-Version: 4.7.2
Homepage: https://invent.kde.org/automotive/kwin-zones
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kwin-zones
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kwin-zones.git

Package: kwin-zones
Architecture: any
Depends: kwin-wayland,
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends}
Description: Client window positioning support for KWin on Wayland
 KWin Zones is a plugin for KWin that implements the xx-zones experimental
 Wayland protocol, allowing applications to give the window manager hints
 on where their windows should be placed.
 .
 This is particularly useful for larger multi-window scientific, CAD or DAW
 applications. To make use of this protocol, the applications or their
 toolkits need to implement xx-zones from wayland-protocols as well.

=== debian/watch ===
Version: 5
Source: https://invent.kde.org/automotive/kwin-zones
Matching-Pattern: refs/tags/@ANY_VERSION@
Mode: git
